package trains.tests;
import trains.model.*;
import trains.persistence.*;
import trains.persistence.binary.CityStations;
import trains.persistence.binary.CityStationsReader;
import static org.junit.Assert.*;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.SortedSet;


import org.junit.Before;
import org.junit.Test;

public class CityStationsTest {
  CityStationsReader cs= null;
	
	@Before
	public void setUp() throws Exception {
		try{
			ByteArrayOutputStream outStream=new ByteArrayOutputStream();
			ObjectOutputStream out= new ObjectOutputStream(outStream);
			out.writeInt(2);
			City c= new City("Bologna");
			Station t=new Station("Bologna", "Centrale");
		    c.getStations().add(t);
		    t=new Station("Bologna", "Corticella");
		    c.getStations().add(t);
		    out.writeObject(c);
		    c= new City("Parma");
		    t=new Station("Parma", "");
		    c.getStations().add(t);
		    out.writeObject(c);
		    out.flush();
		    ByteArrayInputStream inputStream= new ByteArrayInputStream(outStream.toByteArray());
		    cs=new CityStations(inputStream);

			
		}catch(IOException e){e.printStackTrace();}
		catch(InvalidDataException in){in.printStackTrace();}
		
	}

	@Test
	public void testGetStationsCity() {
		SortedSet<Station> stat= cs.getStations(new City("Parma"));
		assertNotNull(stat);
		assertEquals(1,stat.size());
		
	}

	@Test
	public void testGetStationsString() {
		assertNotNull(cs.getStations("Bologna"));
	}

	@Test
	public void testGetCity() {
		assertNotNull(cs.getCity("Bologna Centrale"));
		assertEquals(2,cs.getCity("Bologna Centrale").getStations().size());
		
	}

}
